var flatbuffers = {};

flatbuffers.Offset;

flatbuffers.Table;

flatbuffers.SIZEOF_SHORT = 2;

flatbuffers.SIZEOF_INT = 4;

flatbuffers.FILE_IDENTIFIER_LENGTH = 4;

flatbuffers.Encoding = {
UTF8_BYTES: 1,
UTF16_STRING: 2
};

flatbuffers.int32 = new Int32Array(2);

flatbuffers.float32 = new Float32Array(flatbuffers.int32.buffer);

flatbuffers.float64 = new Float64Array(flatbuffers.int32.buffer);

flatbuffers.isLittleEndian = 1 === new Uint16Array(new Uint8Array([ 1, 0 ]).buffer)[0];

flatbuffers.Long = function(t, e) {
this.low = 0 | t;
this.high = 0 | e;
};

flatbuffers.Long.create = function(t, e) {
return 0 == t && 0 == e ? flatbuffers.Long.ZERO : new flatbuffers.Long(t, e);
};

flatbuffers.Long.prototype.toFloat64 = function() {
return (this.low >>> 0) + 4294967296 * this.high;
};

flatbuffers.Long.prototype.equals = function(t) {
return this.low == t.low && this.high == t.high;
};

flatbuffers.Long.ZERO = new flatbuffers.Long(0, 0);

flatbuffers.Builder = function(t) {
if (t) e = t; else var e = 1024;
this.bb = flatbuffers.ByteBuffer.allocate(e);
this.space = e;
this.minalign = 1;
this.vtable = null;
this.vtable_in_use = 0;
this.isNested = !1;
this.object_start = 0;
this.vtables = [];
this.vector_num_elems = 0;
this.force_defaults = !1;
};

flatbuffers.Builder.prototype.forceDefaults = function(t) {
this.force_defaults = t;
};

flatbuffers.Builder.prototype.dataBuffer = function() {
return this.bb;
};

flatbuffers.Builder.prototype.asUint8Array = function() {
return this.bb.bytes().subarray(this.bb.position(), this.bb.position() + this.offset());
};

flatbuffers.Builder.prototype.prep = function(t, e) {
t > this.minalign && (this.minalign = t);
for (var f = 1 + ~(this.bb.capacity() - this.space + e) & t - 1; this.space < f + t + e; ) {
var r = this.bb.capacity();
this.bb = flatbuffers.Builder.growByteBuffer(this.bb);
this.space += this.bb.capacity() - r;
}
this.pad(f);
};

flatbuffers.Builder.prototype.pad = function(t) {
for (var e = 0; e < t; e++) this.bb.writeInt8(--this.space, 0);
};

flatbuffers.Builder.prototype.writeInt8 = function(t) {
this.bb.writeInt8(this.space -= 1, t);
};

flatbuffers.Builder.prototype.writeInt16 = function(t) {
this.bb.writeInt16(this.space -= 2, t);
};

flatbuffers.Builder.prototype.writeInt32 = function(t) {
this.bb.writeInt32(this.space -= 4, t);
};

flatbuffers.Builder.prototype.writeInt64 = function(t) {
this.bb.writeInt64(this.space -= 8, t);
};

flatbuffers.Builder.prototype.writeFloat32 = function(t) {
this.bb.writeFloat32(this.space -= 4, t);
};

flatbuffers.Builder.prototype.writeFloat64 = function(t) {
this.bb.writeFloat64(this.space -= 8, t);
};

flatbuffers.Builder.prototype.addInt8 = function(t) {
this.prep(1, 0);
this.writeInt8(t);
};

flatbuffers.Builder.prototype.addInt16 = function(t) {
this.prep(2, 0);
this.writeInt16(t);
};

flatbuffers.Builder.prototype.addInt32 = function(t) {
this.prep(4, 0);
this.writeInt32(t);
};

flatbuffers.Builder.prototype.addInt64 = function(t) {
this.prep(8, 0);
this.writeInt64(t);
};

flatbuffers.Builder.prototype.addFloat32 = function(t) {
this.prep(4, 0);
this.writeFloat32(t);
};

flatbuffers.Builder.prototype.addFloat64 = function(t) {
this.prep(8, 0);
this.writeFloat64(t);
};

flatbuffers.Builder.prototype.addFieldInt8 = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addInt8(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldInt16 = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addInt16(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldInt32 = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addInt32(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldInt64 = function(t, e, f) {
if (this.force_defaults || !e.equals(f)) {
this.addInt64(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldFloat32 = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addFloat32(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldFloat64 = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addFloat64(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldOffset = function(t, e, f) {
if (this.force_defaults || e != f) {
this.addOffset(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.addFieldStruct = function(t, e, f) {
if (e != f) {
this.nested(e);
this.slot(t);
}
};

flatbuffers.Builder.prototype.nested = function(t) {
if (t != this.offset()) throw new Error("FlatBuffers: struct must be serialized inline.");
};

flatbuffers.Builder.prototype.notNested = function() {
if (this.isNested) throw new Error("FlatBuffers: object serialization must not be nested.");
};

flatbuffers.Builder.prototype.slot = function(t) {
this.vtable[t] = this.offset();
};

flatbuffers.Builder.prototype.offset = function() {
return this.bb.capacity() - this.space;
};

flatbuffers.Builder.growByteBuffer = function(t) {
var e = t.capacity();
if (3221225472 & e) throw new Error("FlatBuffers: cannot grow buffer beyond 2 gigabytes.");
var f = e << 1, r = flatbuffers.ByteBuffer.allocate(f);
r.setPosition(f - e);
r.bytes().set(t.bytes(), f - e);
return r;
};

flatbuffers.Builder.prototype.addOffset = function(t) {
this.prep(flatbuffers.SIZEOF_INT, 0);
this.writeInt32(this.offset() - t + flatbuffers.SIZEOF_INT);
};

flatbuffers.Builder.prototype.startObject = function(t) {
this.notNested();
null == this.vtable && (this.vtable = []);
this.vtable_in_use = t;
for (var e = 0; e < t; e++) this.vtable[e] = 0;
this.isNested = !0;
this.object_start = this.offset();
};

flatbuffers.Builder.prototype.endObject = function() {
if (null == this.vtable || !this.isNested) throw new Error("FlatBuffers: endObject called without startObject");
this.addInt32(0);
for (var t = this.offset(), e = this.vtable_in_use - 1; e >= 0 && 0 == this.vtable[e]; e--) ;
for (var f = e + 1; e >= 0; e--) this.addInt16(0 != this.vtable[e] ? t - this.vtable[e] : 0);
this.addInt16(t - this.object_start);
var r = (f + 2) * flatbuffers.SIZEOF_SHORT;
this.addInt16(r);
var i = 0, s = this.space;
t: for (e = 0; e < this.vtables.length; e++) {
var n = this.bb.capacity() - this.vtables[e];
if (r == this.bb.readInt16(n)) {
for (var a = flatbuffers.SIZEOF_SHORT; a < r; a += flatbuffers.SIZEOF_SHORT) if (this.bb.readInt16(s + a) != this.bb.readInt16(n + a)) continue t;
i = this.vtables[e];
break;
}
}
if (i) {
this.space = this.bb.capacity() - t;
this.bb.writeInt32(this.space, i - t);
} else {
this.vtables.push(this.offset());
this.bb.writeInt32(this.bb.capacity() - t, this.offset() - t);
}
this.isNested = !1;
return t;
};

flatbuffers.Builder.prototype.finish = function(t, e) {
if (e) {
var f = e;
this.prep(this.minalign, flatbuffers.SIZEOF_INT + flatbuffers.FILE_IDENTIFIER_LENGTH);
if (f.length != flatbuffers.FILE_IDENTIFIER_LENGTH) throw new Error("FlatBuffers: file identifier must be length " + flatbuffers.FILE_IDENTIFIER_LENGTH);
for (var r = flatbuffers.FILE_IDENTIFIER_LENGTH - 1; r >= 0; r--) this.writeInt8(f.charCodeAt(r));
}
this.prep(this.minalign, flatbuffers.SIZEOF_INT);
this.addOffset(t);
this.bb.setPosition(this.space);
};

flatbuffers.Builder.prototype.requiredField = function(t, e) {
var f = this.bb.capacity() - t, r = f - this.bb.readInt32(f);
if (!(0 != this.bb.readInt16(r + e))) throw new Error("FlatBuffers: field " + e + " must be set");
};

flatbuffers.Builder.prototype.startVector = function(t, e, f) {
this.notNested();
this.vector_num_elems = e;
this.prep(flatbuffers.SIZEOF_INT, t * e);
this.prep(f, t * e);
};

flatbuffers.Builder.prototype.endVector = function() {
this.writeInt32(this.vector_num_elems);
return this.offset();
};

flatbuffers.Builder.prototype.createString = function(t) {
if (t instanceof Uint8Array) var e = t; else {
e = [];
for (var f = 0; f < t.length; ) {
var r, i = t.charCodeAt(f++);
if (i < 55296 || i >= 56320) r = i; else {
r = (i << 10) + t.charCodeAt(f++) + -56613888;
}
if (r < 128) e.push(r); else {
if (r < 2048) e.push(r >> 6 & 31 | 192); else {
r < 65536 ? e.push(r >> 12 & 15 | 224) : e.push(r >> 18 & 7 | 240, r >> 12 & 63 | 128);
e.push(r >> 6 & 63 | 128);
}
e.push(63 & r | 128);
}
}
}
this.addInt8(0);
this.startVector(1, e.length, 1);
this.bb.setPosition(this.space -= e.length);
f = 0;
for (var s = this.space, n = this.bb.bytes(); f < e.length; f++) n[s++] = e[f];
return this.endVector();
};

flatbuffers.Builder.prototype.createLong = function(t, e) {
return flatbuffers.Long.create(t, e);
};

flatbuffers.ByteBuffer = function(t) {
this.bytes_ = t;
this.position_ = 0;
};

flatbuffers.ByteBuffer.allocate = function(t) {
return new flatbuffers.ByteBuffer(new Uint8Array(t));
};

flatbuffers.ByteBuffer.prototype.bytes = function() {
return this.bytes_;
};

flatbuffers.ByteBuffer.prototype.position = function() {
return this.position_;
};

flatbuffers.ByteBuffer.prototype.setPosition = function(t) {
this.position_ = t;
};

flatbuffers.ByteBuffer.prototype.capacity = function() {
return this.bytes_.length;
};

flatbuffers.ByteBuffer.prototype.readInt8 = function(t) {
return this.readUint8(t) << 24 >> 24;
};

flatbuffers.ByteBuffer.prototype.readUint8 = function(t) {
return this.bytes_[t];
};

flatbuffers.ByteBuffer.prototype.readInt16 = function(t) {
return this.readUint16(t) << 16 >> 16;
};

flatbuffers.ByteBuffer.prototype.readUint16 = function(t) {
return this.bytes_[t] | this.bytes_[t + 1] << 8;
};

flatbuffers.ByteBuffer.prototype.readInt32 = function(t) {
return this.bytes_[t] | this.bytes_[t + 1] << 8 | this.bytes_[t + 2] << 16 | this.bytes_[t + 3] << 24;
};

flatbuffers.ByteBuffer.prototype.readUint32 = function(t) {
return this.readInt32(t) >>> 0;
};

flatbuffers.ByteBuffer.prototype.readInt64 = function(t) {
return new flatbuffers.Long(this.readInt32(t), this.readInt32(t + 4));
};

flatbuffers.ByteBuffer.prototype.readUint64 = function(t) {
return new flatbuffers.Long(this.readUint32(t), this.readUint32(t + 4));
};

flatbuffers.ByteBuffer.prototype.readFloat32 = function(t) {
flatbuffers.int32[0] = this.readInt32(t);
return flatbuffers.float32[0];
};

flatbuffers.ByteBuffer.prototype.readFloat64 = function(t) {
flatbuffers.int32[flatbuffers.isLittleEndian ? 0 : 1] = this.readInt32(t);
flatbuffers.int32[flatbuffers.isLittleEndian ? 1 : 0] = this.readInt32(t + 4);
return flatbuffers.float64[0];
};

flatbuffers.ByteBuffer.prototype.writeInt8 = function(t, e) {
this.bytes_[t] = e;
};

flatbuffers.ByteBuffer.prototype.writeUint8 = function(t, e) {
this.bytes_[t] = e;
};

flatbuffers.ByteBuffer.prototype.writeInt16 = function(t, e) {
this.bytes_[t] = e;
this.bytes_[t + 1] = e >> 8;
};

flatbuffers.ByteBuffer.prototype.writeUint16 = function(t, e) {
this.bytes_[t] = e;
this.bytes_[t + 1] = e >> 8;
};

flatbuffers.ByteBuffer.prototype.writeInt32 = function(t, e) {
this.bytes_[t] = e;
this.bytes_[t + 1] = e >> 8;
this.bytes_[t + 2] = e >> 16;
this.bytes_[t + 3] = e >> 24;
};

flatbuffers.ByteBuffer.prototype.writeUint32 = function(t, e) {
this.bytes_[t] = e;
this.bytes_[t + 1] = e >> 8;
this.bytes_[t + 2] = e >> 16;
this.bytes_[t + 3] = e >> 24;
};

flatbuffers.ByteBuffer.prototype.writeInt64 = function(t, e) {
this.writeInt32(t, e.low);
this.writeInt32(t + 4, e.high);
};

flatbuffers.ByteBuffer.prototype.writeUint64 = function(t, e) {
this.writeUint32(t, e.low);
this.writeUint32(t + 4, e.high);
};

flatbuffers.ByteBuffer.prototype.writeFloat32 = function(t, e) {
flatbuffers.float32[0] = e;
this.writeInt32(t, flatbuffers.int32[0]);
};

flatbuffers.ByteBuffer.prototype.writeFloat64 = function(t, e) {
flatbuffers.float64[0] = e;
this.writeInt32(t, flatbuffers.int32[flatbuffers.isLittleEndian ? 0 : 1]);
this.writeInt32(t + 4, flatbuffers.int32[flatbuffers.isLittleEndian ? 1 : 0]);
};

flatbuffers.ByteBuffer.prototype.getBufferIdentifier = function() {
if (this.bytes_.length < this.position_ + flatbuffers.SIZEOF_INT + flatbuffers.FILE_IDENTIFIER_LENGTH) throw new Error("FlatBuffers: ByteBuffer is too short to contain an identifier.");
for (var t = "", e = 0; e < flatbuffers.FILE_IDENTIFIER_LENGTH; e++) t += String.fromCharCode(this.readInt8(this.position_ + flatbuffers.SIZEOF_INT + e));
return t;
};

flatbuffers.ByteBuffer.prototype.__offset = function(t, e) {
var f = t - this.readInt32(t);
return e < this.readInt16(f) ? this.readInt16(f + e) : 0;
};

flatbuffers.ByteBuffer.prototype.__union = function(t, e) {
t.bb_pos = e + this.readInt32(e);
t.bb = this;
return t;
};

flatbuffers.ByteBuffer.prototype.__string = function(t, e) {
t += this.readInt32(t);
var f = this.readInt32(t), r = "", i = 0;
t += flatbuffers.SIZEOF_INT;
if (e === flatbuffers.Encoding.UTF8_BYTES) return this.bytes_.subarray(t, t + f);
for (;i < f; ) {
var s, n = this.readUint8(t + i++);
if (n < 192) s = n; else {
var a = this.readUint8(t + i++);
if (n < 224) s = (31 & n) << 6 | 63 & a; else {
var o = this.readUint8(t + i++);
if (n < 240) s = (15 & n) << 12 | (63 & a) << 6 | 63 & o; else {
s = (7 & n) << 18 | (63 & a) << 12 | (63 & o) << 6 | 63 & this.readUint8(t + i++);
}
}
}
if (s < 65536) r += String.fromCharCode(s); else {
s -= 65536;
r += String.fromCharCode(55296 + (s >> 10), 56320 + (1023 & s));
}
}
return r;
};

flatbuffers.ByteBuffer.prototype.__indirect = function(t) {
return t + this.readInt32(t);
};

flatbuffers.ByteBuffer.prototype.__vector = function(t) {
return t + this.readInt32(t) + flatbuffers.SIZEOF_INT;
};

flatbuffers.ByteBuffer.prototype.__vector_len = function(t) {
return this.readInt32(t + this.readInt32(t));
};

flatbuffers.ByteBuffer.prototype.__has_identifier = function(t) {
if (t.length != flatbuffers.FILE_IDENTIFIER_LENGTH) throw new Error("FlatBuffers: file identifier must be length " + flatbuffers.FILE_IDENTIFIER_LENGTH);
for (var e = 0; e < flatbuffers.FILE_IDENTIFIER_LENGTH; e++) if (t.charCodeAt(e) != this.readInt8(this.position_ + flatbuffers.SIZEOF_INT + e)) return !1;
return !0;
};

flatbuffers.ByteBuffer.prototype.createLong = function(t, e) {
return flatbuffers.Long.create(t, e);
};

this && (this.flatbuffers = flatbuffers);